<?php

/**
 * Base class that represents a row from the 'katao_supplier_invoice' table.
 *
 * 
 *
 * @package    lib.model.om
 */
abstract class BaseKataoSupplierInvoice extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        KataoSupplierInvoicePeer
	 */
	protected static $peer;


	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;


	/**
	 * The value for the katao_supplier_id field.
	 * @var        int
	 */
	protected $katao_supplier_id;


	/**
	 * The value for the katao_period_id field.
	 * @var        int
	 */
	protected $katao_period_id;


	/**
	 * The value for the status field.
	 * @var        int
	 */
	protected $status = 1;


	/**
	 * The value for the supplier_name field.
	 * @var        string
	 */
	protected $supplier_name;


	/**
	 * The value for the supplier_email field.
	 * @var        string
	 */
	protected $supplier_email;


	/**
	 * The value for the supplier_address1 field.
	 * @var        string
	 */
	protected $supplier_address1;


	/**
	 * The value for the supplier_address2 field.
	 * @var        string
	 */
	protected $supplier_address2;


	/**
	 * The value for the supplier_zip field.
	 * @var        string
	 */
	protected $supplier_zip;


	/**
	 * The value for the supplier_city field.
	 * @var        string
	 */
	protected $supplier_city;


	/**
	 * The value for the katao_name field.
	 * @var        string
	 */
	protected $katao_name;


	/**
	 * The value for the katao_address field.
	 * @var        string
	 */
	protected $katao_address;


	/**
	 * The value for the katao_siret_number field.
	 * @var        string
	 */
	protected $katao_siret_number;


	/**
	 * The value for the katao_rcs_number field.
	 * @var        string
	 */
	protected $katao_rcs_number;


	/**
	 * The value for the katao_capital field.
	 * @var        int
	 */
	protected $katao_capital;


	/**
	 * The value for the reference field.
	 * @var        string
	 */
	protected $reference;


	/**
	 * The value for the invoice_date field.
	 * @var        int
	 */
	protected $invoice_date;


	/**
	 * The value for the due_date field.
	 * @var        int
	 */
	protected $due_date;


	/**
	 * The value for the payment_date field.
	 * @var        int
	 */
	protected $payment_date;


	/**
	 * The value for the payment_mode field.
	 * @var        int
	 */
	protected $payment_mode = 1;


	/**
	 * The value for the payment_details field.
	 * @var        string
	 */
	protected $payment_details;


	/**
	 * The value for the payment_amount_euro field.
	 * @var        double
	 */
	protected $payment_amount_euro = 0;


	/**
	 * The value for the payment_amount_sol field.
	 * @var        double
	 */
	protected $payment_amount_sol = 0;


	/**
	 * The value for the taux0_bases_ht field.
	 * @var        double
	 */
	protected $taux0_bases_ht = 0;


	/**
	 * The value for the taux0_discount_ht field.
	 * @var        double
	 */
	protected $taux0_discount_ht = 0;


	/**
	 * The value for the taux0_amount field.
	 * @var        double
	 */
	protected $taux0_amount = 0;


	/**
	 * The value for the taux1_bases_ht field.
	 * @var        double
	 */
	protected $taux1_bases_ht = 0;


	/**
	 * The value for the taux1_discount_ht field.
	 * @var        double
	 */
	protected $taux1_discount_ht = 0;


	/**
	 * The value for the taux1_amount field.
	 * @var        double
	 */
	protected $taux1_amount = 0;


	/**
	 * The value for the taux2_bases_ht field.
	 * @var        double
	 */
	protected $taux2_bases_ht = 0;


	/**
	 * The value for the taux2_discount_ht field.
	 * @var        double
	 */
	protected $taux2_discount_ht = 0;


	/**
	 * The value for the taux2_amount field.
	 * @var        double
	 */
	protected $taux2_amount = 0;


	/**
	 * The value for the total_ht field.
	 * @var        double
	 */
	protected $total_ht = 0;


	/**
	 * The value for the total_tva field.
	 * @var        double
	 */
	protected $total_tva = 0;


	/**
	 * The value for the comment field.
	 * @var        string
	 */
	protected $comment;


	/**
	 * The value for the fees_shipping_ht field.
	 * @var        double
	 */
	protected $fees_shipping_ht = 0;


	/**
	 * The value for the fees_shipping_rate field.
	 * @var        double
	 */
	protected $fees_shipping_rate = 0;


	/**
	 * The value for the fees_shipping_tva field.
	 * @var        double
	 */
	protected $fees_shipping_tva = 0;


	/**
	 * The value for the fees_billing_ht field.
	 * @var        double
	 */
	protected $fees_billing_ht = 0;


	/**
	 * The value for the fees_billing_rate field.
	 * @var        double
	 */
	protected $fees_billing_rate = 0;


	/**
	 * The value for the fees_billing_tva field.
	 * @var        double
	 */
	protected $fees_billing_tva = 0;


	/**
	 * The value for the created_at field.
	 * @var        int
	 */
	protected $created_at;


	/**
	 * The value for the updated_at field.
	 * @var        int
	 */
	protected $updated_at;

	/**
	 * @var        KataoSupplier
	 */
	protected $aKataoSupplier;

	/**
	 * @var        KataoPeriod
	 */
	protected $aKataoPeriod;

	/**
	 * Collection to store aggregation of collKataoSupplierInvoiceProducts.
	 * @var        array
	 */
	protected $collKataoSupplierInvoiceProducts;

	/**
	 * The criteria used to select the current contents of collKataoSupplierInvoiceProducts.
	 * @var        Criteria
	 */
	protected $lastKataoSupplierInvoiceProductCriteria = null;

	/**
	 * Collection to store aggregation of collKataoSupplierInvoiceOrders.
	 * @var        array
	 */
	protected $collKataoSupplierInvoiceOrders;

	/**
	 * The criteria used to select the current contents of collKataoSupplierInvoiceOrders.
	 * @var        Criteria
	 */
	protected $lastKataoSupplierInvoiceOrderCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{

		return $this->id;
	}

	/**
	 * Get the [katao_supplier_id] column value.
	 * 
	 * @return     int
	 */
	public function getKataoSupplierId()
	{

		return $this->katao_supplier_id;
	}

	/**
	 * Get the [katao_period_id] column value.
	 * 
	 * @return     int
	 */
	public function getKataoPeriodId()
	{

		return $this->katao_period_id;
	}

	/**
	 * Get the [status] column value.
	 * 
	 * @return     int
	 */
	public function getStatus()
	{

		return $this->status;
	}

	/**
	 * Get the [supplier_name] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierName()
	{

		return $this->supplier_name;
	}

	/**
	 * Get the [supplier_email] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierEmail()
	{

		return $this->supplier_email;
	}

	/**
	 * Get the [supplier_address1] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierAddress1()
	{

		return $this->supplier_address1;
	}

	/**
	 * Get the [supplier_address2] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierAddress2()
	{

		return $this->supplier_address2;
	}

	/**
	 * Get the [supplier_zip] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierZip()
	{

		return $this->supplier_zip;
	}

	/**
	 * Get the [supplier_city] column value.
	 * 
	 * @return     string
	 */
	public function getSupplierCity()
	{

		return $this->supplier_city;
	}

	/**
	 * Get the [katao_name] column value.
	 * 
	 * @return     string
	 */
	public function getKataoName()
	{

		return $this->katao_name;
	}

	/**
	 * Get the [katao_address] column value.
	 * 
	 * @return     string
	 */
	public function getKataoAddress()
	{

		return $this->katao_address;
	}

	/**
	 * Get the [katao_siret_number] column value.
	 * 
	 * @return     string
	 */
	public function getKataoSiretNumber()
	{

		return $this->katao_siret_number;
	}

	/**
	 * Get the [katao_rcs_number] column value.
	 * 
	 * @return     string
	 */
	public function getKataoRcsNumber()
	{

		return $this->katao_rcs_number;
	}

	/**
	 * Get the [katao_capital] column value.
	 * 
	 * @return     int
	 */
	public function getKataoCapital()
	{

		return $this->katao_capital;
	}

	/**
	 * Get the [reference] column value.
	 * 
	 * @return     string
	 */
	public function getReference()
	{

		return $this->reference;
	}

	/**
	 * Get the [optionally formatted] [invoice_date] column value.
	 * 
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return     mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws     PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getInvoiceDate($format = 'Y-m-d H:i:s')
	{

		if ($this->invoice_date === null || $this->invoice_date === '') {
			return null;
		} elseif (!is_int($this->invoice_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->invoice_date);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [invoice_date] as date/time value: " . var_export($this->invoice_date, true));
			}
		} else {
			$ts = $this->invoice_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [optionally formatted] [due_date] column value.
	 * 
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return     mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws     PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getDueDate($format = 'Y-m-d H:i:s')
	{

		if ($this->due_date === null || $this->due_date === '') {
			return null;
		} elseif (!is_int($this->due_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->due_date);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [due_date] as date/time value: " . var_export($this->due_date, true));
			}
		} else {
			$ts = $this->due_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [optionally formatted] [payment_date] column value.
	 * 
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return     mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws     PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getPaymentDate($format = 'Y-m-d H:i:s')
	{

		if ($this->payment_date === null || $this->payment_date === '') {
			return null;
		} elseif (!is_int($this->payment_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->payment_date);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [payment_date] as date/time value: " . var_export($this->payment_date, true));
			}
		} else {
			$ts = $this->payment_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [payment_mode] column value.
	 * 
	 * @return     int
	 */
	public function getPaymentMode()
	{

		return $this->payment_mode;
	}

	/**
	 * Get the [payment_details] column value.
	 * 
	 * @return     string
	 */
	public function getPaymentDetails()
	{

		return $this->payment_details;
	}

	/**
	 * Get the [payment_amount_euro] column value.
	 * 
	 * @return     double
	 */
	public function getPaymentAmountEuro()
	{

		return $this->payment_amount_euro;
	}

	/**
	 * Get the [payment_amount_sol] column value.
	 * 
	 * @return     double
	 */
	public function getPaymentAmountSol()
	{

		return $this->payment_amount_sol;
	}

	/**
	 * Get the [taux0_bases_ht] column value.
	 * 
	 * @return     double
	 */
	public function getTaux0BasesHt()
	{

		return $this->taux0_bases_ht;
	}

	/**
	 * Get the [taux0_discount_ht] column value.
	 * 
	 * @return     double
	 */
	public function getTaux0DiscountHt()
	{

		return $this->taux0_discount_ht;
	}

	/**
	 * Get the [taux0_amount] column value.
	 * 
	 * @return     double
	 */
	public function getTaux0Amount()
	{

		return $this->taux0_amount;
	}

	/**
	 * Get the [taux1_bases_ht] column value.
	 * 
	 * @return     double
	 */
	public function getTaux1BasesHt()
	{

		return $this->taux1_bases_ht;
	}

	/**
	 * Get the [taux1_discount_ht] column value.
	 * 
	 * @return     double
	 */
	public function getTaux1DiscountHt()
	{

		return $this->taux1_discount_ht;
	}

	/**
	 * Get the [taux1_amount] column value.
	 * 
	 * @return     double
	 */
	public function getTaux1Amount()
	{

		return $this->taux1_amount;
	}

	/**
	 * Get the [taux2_bases_ht] column value.
	 * 
	 * @return     double
	 */
	public function getTaux2BasesHt()
	{

		return $this->taux2_bases_ht;
	}

	/**
	 * Get the [taux2_discount_ht] column value.
	 * 
	 * @return     double
	 */
	public function getTaux2DiscountHt()
	{

		return $this->taux2_discount_ht;
	}

	/**
	 * Get the [taux2_amount] column value.
	 * 
	 * @return     double
	 */
	public function getTaux2Amount()
	{

		return $this->taux2_amount;
	}

	/**
	 * Get the [total_ht] column value.
	 * 
	 * @return     double
	 */
	public function getTotalHt()
	{

		return $this->total_ht;
	}

	/**
	 * Get the [total_tva] column value.
	 * 
	 * @return     double
	 */
	public function getTotalTva()
	{

		return $this->total_tva;
	}

	/**
	 * Get the [comment] column value.
	 * 
	 * @return     string
	 */
	public function getComment()
	{

		return $this->comment;
	}

	/**
	 * Get the [fees_shipping_ht] column value.
	 * 
	 * @return     double
	 */
	public function getFeesShippingHt()
	{

		return $this->fees_shipping_ht;
	}

	/**
	 * Get the [fees_shipping_rate] column value.
	 * 
	 * @return     double
	 */
	public function getFeesShippingRate()
	{

		return $this->fees_shipping_rate;
	}

	/**
	 * Get the [fees_shipping_tva] column value.
	 * 
	 * @return     double
	 */
	public function getFeesShippingTva()
	{

		return $this->fees_shipping_tva;
	}

	/**
	 * Get the [fees_billing_ht] column value.
	 * 
	 * @return     double
	 */
	public function getFeesBillingHt()
	{

		return $this->fees_billing_ht;
	}

	/**
	 * Get the [fees_billing_rate] column value.
	 * 
	 * @return     double
	 */
	public function getFeesBillingRate()
	{

		return $this->fees_billing_rate;
	}

	/**
	 * Get the [fees_billing_tva] column value.
	 * 
	 * @return     double
	 */
	public function getFeesBillingTva()
	{

		return $this->fees_billing_tva;
	}

	/**
	 * Get the [optionally formatted] [created_at] column value.
	 * 
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return     mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws     PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [optionally formatted] [updated_at] column value.
	 * 
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return     mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws     PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->updated_at === null || $this->updated_at === '') {
			return null;
		} elseif (!is_int($this->updated_at)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->updated_at);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [updated_at] as date/time value: " . var_export($this->updated_at, true));
			}
		} else {
			$ts = $this->updated_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::ID;
		}

	} // setId()

	/**
	 * Set the value of [katao_supplier_id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoSupplierId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_supplier_id !== $v) {
			$this->katao_supplier_id = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::KATAO_SUPPLIER_ID;
		}

		if ($this->aKataoSupplier !== null && $this->aKataoSupplier->getId() !== $v) {
			$this->aKataoSupplier = null;
		}

	} // setKataoSupplierId()

	/**
	 * Set the value of [katao_period_id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoPeriodId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_period_id !== $v) {
			$this->katao_period_id = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::KATAO_PERIOD_ID;
		}

		if ($this->aKataoPeriod !== null && $this->aKataoPeriod->getId() !== $v) {
			$this->aKataoPeriod = null;
		}

	} // setKataoPeriodId()

	/**
	 * Set the value of [status] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setStatus($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->status !== $v || $v === 1) {
			$this->status = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::STATUS;
		}

	} // setStatus()

	/**
	 * Set the value of [supplier_name] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierName($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_name !== $v) {
			$this->supplier_name = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::SUPPLIER_NAME;
		}

	} // setSupplierName()

	/**
	 * Set the value of [supplier_email] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierEmail($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_email !== $v) {
			$this->supplier_email = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::SUPPLIER_EMAIL;
		}

	} // setSupplierEmail()

	/**
	 * Set the value of [supplier_address1] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierAddress1($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_address1 !== $v) {
			$this->supplier_address1 = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::SUPPLIER_ADDRESS1;
		}

	} // setSupplierAddress1()

	/**
	 * Set the value of [supplier_address2] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierAddress2($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_address2 !== $v) {
			$this->supplier_address2 = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::SUPPLIER_ADDRESS2;
		}

	} // setSupplierAddress2()

	/**
	 * Set the value of [supplier_zip] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierZip($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_zip !== $v) {
			$this->supplier_zip = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::SUPPLIER_ZIP;
		}

	} // setSupplierZip()

	/**
	 * Set the value of [supplier_city] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setSupplierCity($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->supplier_city !== $v) {
			$this->supplier_city = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::SUPPLIER_CITY;
		}

	} // setSupplierCity()

	/**
	 * Set the value of [katao_name] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoName($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_name !== $v) {
			$this->katao_name = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::KATAO_NAME;
		}

	} // setKataoName()

	/**
	 * Set the value of [katao_address] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoAddress($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_address !== $v) {
			$this->katao_address = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::KATAO_ADDRESS;
		}

	} // setKataoAddress()

	/**
	 * Set the value of [katao_siret_number] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoSiretNumber($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_siret_number !== $v) {
			$this->katao_siret_number = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::KATAO_SIRET_NUMBER;
		}

	} // setKataoSiretNumber()

	/**
	 * Set the value of [katao_rcs_number] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoRcsNumber($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_rcs_number !== $v) {
			$this->katao_rcs_number = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::KATAO_RCS_NUMBER;
		}

	} // setKataoRcsNumber()

	/**
	 * Set the value of [katao_capital] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoCapital($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_capital !== $v) {
			$this->katao_capital = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::KATAO_CAPITAL;
		}

	} // setKataoCapital()

	/**
	 * Set the value of [reference] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setReference($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->reference !== $v) {
			$this->reference = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::REFERENCE;
		}

	} // setReference()

	/**
	 * Set the value of [invoice_date] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setInvoiceDate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [invoice_date] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->invoice_date !== $ts) {
			$this->invoice_date = $ts;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::INVOICE_DATE;
		}

	} // setInvoiceDate()

	/**
	 * Set the value of [due_date] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setDueDate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [due_date] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->due_date !== $ts) {
			$this->due_date = $ts;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::DUE_DATE;
		}

	} // setDueDate()

	/**
	 * Set the value of [payment_date] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setPaymentDate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [payment_date] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->payment_date !== $ts) {
			$this->payment_date = $ts;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::PAYMENT_DATE;
		}

	} // setPaymentDate()

	/**
	 * Set the value of [payment_mode] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setPaymentMode($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->payment_mode !== $v || $v === 1) {
			$this->payment_mode = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::PAYMENT_MODE;
		}

	} // setPaymentMode()

	/**
	 * Set the value of [payment_details] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setPaymentDetails($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->payment_details !== $v) {
			$this->payment_details = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::PAYMENT_DETAILS;
		}

	} // setPaymentDetails()

	/**
	 * Set the value of [payment_amount_euro] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setPaymentAmountEuro($v)
	{

		if ($this->payment_amount_euro !== $v || $v === 0) {
			$this->payment_amount_euro = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::PAYMENT_AMOUNT_EURO;
		}

	} // setPaymentAmountEuro()

	/**
	 * Set the value of [payment_amount_sol] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setPaymentAmountSol($v)
	{

		if ($this->payment_amount_sol !== $v || $v === 0) {
			$this->payment_amount_sol = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::PAYMENT_AMOUNT_SOL;
		}

	} // setPaymentAmountSol()

	/**
	 * Set the value of [taux0_bases_ht] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setTaux0BasesHt($v)
	{

		if ($this->taux0_bases_ht !== $v || $v === 0) {
			$this->taux0_bases_ht = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::TAUX0_BASES_HT;
		}

	} // setTaux0BasesHt()

	/**
	 * Set the value of [taux0_discount_ht] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setTaux0DiscountHt($v)
	{

		if ($this->taux0_discount_ht !== $v || $v === 0) {
			$this->taux0_discount_ht = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::TAUX0_DISCOUNT_HT;
		}

	} // setTaux0DiscountHt()

	/**
	 * Set the value of [taux0_amount] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setTaux0Amount($v)
	{

		if ($this->taux0_amount !== $v || $v === 0) {
			$this->taux0_amount = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::TAUX0_AMOUNT;
		}

	} // setTaux0Amount()

	/**
	 * Set the value of [taux1_bases_ht] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setTaux1BasesHt($v)
	{

		if ($this->taux1_bases_ht !== $v || $v === 0) {
			$this->taux1_bases_ht = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::TAUX1_BASES_HT;
		}

	} // setTaux1BasesHt()

	/**
	 * Set the value of [taux1_discount_ht] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setTaux1DiscountHt($v)
	{

		if ($this->taux1_discount_ht !== $v || $v === 0) {
			$this->taux1_discount_ht = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::TAUX1_DISCOUNT_HT;
		}

	} // setTaux1DiscountHt()

	/**
	 * Set the value of [taux1_amount] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setTaux1Amount($v)
	{

		if ($this->taux1_amount !== $v || $v === 0) {
			$this->taux1_amount = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::TAUX1_AMOUNT;
		}

	} // setTaux1Amount()

	/**
	 * Set the value of [taux2_bases_ht] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setTaux2BasesHt($v)
	{

		if ($this->taux2_bases_ht !== $v || $v === 0) {
			$this->taux2_bases_ht = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::TAUX2_BASES_HT;
		}

	} // setTaux2BasesHt()

	/**
	 * Set the value of [taux2_discount_ht] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setTaux2DiscountHt($v)
	{

		if ($this->taux2_discount_ht !== $v || $v === 0) {
			$this->taux2_discount_ht = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::TAUX2_DISCOUNT_HT;
		}

	} // setTaux2DiscountHt()

	/**
	 * Set the value of [taux2_amount] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setTaux2Amount($v)
	{

		if ($this->taux2_amount !== $v || $v === 0) {
			$this->taux2_amount = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::TAUX2_AMOUNT;
		}

	} // setTaux2Amount()

	/**
	 * Set the value of [total_ht] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setTotalHt($v)
	{

		if ($this->total_ht !== $v || $v === 0) {
			$this->total_ht = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::TOTAL_HT;
		}

	} // setTotalHt()

	/**
	 * Set the value of [total_tva] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setTotalTva($v)
	{

		if ($this->total_tva !== $v || $v === 0) {
			$this->total_tva = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::TOTAL_TVA;
		}

	} // setTotalTva()

	/**
	 * Set the value of [comment] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setComment($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->comment !== $v) {
			$this->comment = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::COMMENT;
		}

	} // setComment()

	/**
	 * Set the value of [fees_shipping_ht] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setFeesShippingHt($v)
	{

		if ($this->fees_shipping_ht !== $v || $v === 0) {
			$this->fees_shipping_ht = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::FEES_SHIPPING_HT;
		}

	} // setFeesShippingHt()

	/**
	 * Set the value of [fees_shipping_rate] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setFeesShippingRate($v)
	{

		if ($this->fees_shipping_rate !== $v || $v === 0) {
			$this->fees_shipping_rate = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::FEES_SHIPPING_RATE;
		}

	} // setFeesShippingRate()

	/**
	 * Set the value of [fees_shipping_tva] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setFeesShippingTva($v)
	{

		if ($this->fees_shipping_tva !== $v || $v === 0) {
			$this->fees_shipping_tva = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::FEES_SHIPPING_TVA;
		}

	} // setFeesShippingTva()

	/**
	 * Set the value of [fees_billing_ht] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setFeesBillingHt($v)
	{

		if ($this->fees_billing_ht !== $v || $v === 0) {
			$this->fees_billing_ht = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::FEES_BILLING_HT;
		}

	} // setFeesBillingHt()

	/**
	 * Set the value of [fees_billing_rate] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setFeesBillingRate($v)
	{

		if ($this->fees_billing_rate !== $v || $v === 0) {
			$this->fees_billing_rate = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::FEES_BILLING_RATE;
		}

	} // setFeesBillingRate()

	/**
	 * Set the value of [fees_billing_tva] column.
	 * 
	 * @param      double $v new value
	 * @return     void
	 */
	public function setFeesBillingTva($v)
	{

		if ($this->fees_billing_tva !== $v || $v === 0) {
			$this->fees_billing_tva = $v;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::FEES_BILLING_TVA;
		}

	} // setFeesBillingTva()

	/**
	 * Set the value of [created_at] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::CREATED_AT;
		}

	} // setCreatedAt()

	/**
	 * Set the value of [updated_at] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setUpdatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [updated_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->updated_at !== $ts) {
			$this->updated_at = $ts;
			$this->modifiedColumns[] = KataoSupplierInvoicePeer::UPDATED_AT;
		}

	} // setUpdatedAt()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param      int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->katao_supplier_id = $rs->getInt($startcol + 1);

			$this->katao_period_id = $rs->getInt($startcol + 2);

			$this->status = $rs->getInt($startcol + 3);

			$this->supplier_name = $rs->getString($startcol + 4);

			$this->supplier_email = $rs->getString($startcol + 5);

			$this->supplier_address1 = $rs->getString($startcol + 6);

			$this->supplier_address2 = $rs->getString($startcol + 7);

			$this->supplier_zip = $rs->getString($startcol + 8);

			$this->supplier_city = $rs->getString($startcol + 9);

			$this->katao_name = $rs->getString($startcol + 10);

			$this->katao_address = $rs->getString($startcol + 11);

			$this->katao_siret_number = $rs->getString($startcol + 12);

			$this->katao_rcs_number = $rs->getString($startcol + 13);

			$this->katao_capital = $rs->getInt($startcol + 14);

			$this->reference = $rs->getString($startcol + 15);

			$this->invoice_date = $rs->getTimestamp($startcol + 16, null);

			$this->due_date = $rs->getTimestamp($startcol + 17, null);

			$this->payment_date = $rs->getTimestamp($startcol + 18, null);

			$this->payment_mode = $rs->getInt($startcol + 19);

			$this->payment_details = $rs->getString($startcol + 20);

			$this->payment_amount_euro = $rs->getFloat($startcol + 21);

			$this->payment_amount_sol = $rs->getFloat($startcol + 22);

			$this->taux0_bases_ht = $rs->getFloat($startcol + 23);

			$this->taux0_discount_ht = $rs->getFloat($startcol + 24);

			$this->taux0_amount = $rs->getFloat($startcol + 25);

			$this->taux1_bases_ht = $rs->getFloat($startcol + 26);

			$this->taux1_discount_ht = $rs->getFloat($startcol + 27);

			$this->taux1_amount = $rs->getFloat($startcol + 28);

			$this->taux2_bases_ht = $rs->getFloat($startcol + 29);

			$this->taux2_discount_ht = $rs->getFloat($startcol + 30);

			$this->taux2_amount = $rs->getFloat($startcol + 31);

			$this->total_ht = $rs->getFloat($startcol + 32);

			$this->total_tva = $rs->getFloat($startcol + 33);

			$this->comment = $rs->getString($startcol + 34);

			$this->fees_shipping_ht = $rs->getFloat($startcol + 35);

			$this->fees_shipping_rate = $rs->getFloat($startcol + 36);

			$this->fees_shipping_tva = $rs->getFloat($startcol + 37);

			$this->fees_billing_ht = $rs->getFloat($startcol + 38);

			$this->fees_billing_rate = $rs->getFloat($startcol + 39);

			$this->fees_billing_tva = $rs->getFloat($startcol + 40);

			$this->created_at = $rs->getTimestamp($startcol + 41, null);

			$this->updated_at = $rs->getTimestamp($startcol + 42, null);

			$this->resetModified();

			$this->setNew(false);

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 43; // 43 = KataoSupplierInvoicePeer::NUM_COLUMNS - KataoSupplierInvoicePeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating KataoSupplierInvoice object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      Connection $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoSupplierInvoice:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KataoSupplierInvoicePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			KataoSupplierInvoicePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseKataoSupplierInvoice:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param      Connection $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoSupplierInvoice:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(KataoSupplierInvoicePeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(KataoSupplierInvoicePeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KataoSupplierInvoicePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseKataoSupplierInvoice:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      Connection $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aKataoSupplier !== null) {
				if ($this->aKataoSupplier->isModified()) {
					$affectedRows += $this->aKataoSupplier->save($con);
				}
				$this->setKataoSupplier($this->aKataoSupplier);
			}

			if ($this->aKataoPeriod !== null) {
				if ($this->aKataoPeriod->isModified()) {
					$affectedRows += $this->aKataoPeriod->save($con);
				}
				$this->setKataoPeriod($this->aKataoPeriod);
			}


			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = KataoSupplierInvoicePeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += KataoSupplierInvoicePeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collKataoSupplierInvoiceProducts !== null) {
				foreach($this->collKataoSupplierInvoiceProducts as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collKataoSupplierInvoiceOrders !== null) {
				foreach($this->collKataoSupplierInvoiceOrders as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aKataoSupplier !== null) {
				if (!$this->aKataoSupplier->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aKataoSupplier->getValidationFailures());
				}
			}

			if ($this->aKataoPeriod !== null) {
				if (!$this->aKataoPeriod->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aKataoPeriod->getValidationFailures());
				}
			}


			if (($retval = KataoSupplierInvoicePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collKataoSupplierInvoiceProducts !== null) {
					foreach($this->collKataoSupplierInvoiceProducts as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collKataoSupplierInvoiceOrders !== null) {
					foreach($this->collKataoSupplierInvoiceOrders as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KataoSupplierInvoicePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getKataoSupplierId();
				break;
			case 2:
				return $this->getKataoPeriodId();
				break;
			case 3:
				return $this->getStatus();
				break;
			case 4:
				return $this->getSupplierName();
				break;
			case 5:
				return $this->getSupplierEmail();
				break;
			case 6:
				return $this->getSupplierAddress1();
				break;
			case 7:
				return $this->getSupplierAddress2();
				break;
			case 8:
				return $this->getSupplierZip();
				break;
			case 9:
				return $this->getSupplierCity();
				break;
			case 10:
				return $this->getKataoName();
				break;
			case 11:
				return $this->getKataoAddress();
				break;
			case 12:
				return $this->getKataoSiretNumber();
				break;
			case 13:
				return $this->getKataoRcsNumber();
				break;
			case 14:
				return $this->getKataoCapital();
				break;
			case 15:
				return $this->getReference();
				break;
			case 16:
				return $this->getInvoiceDate();
				break;
			case 17:
				return $this->getDueDate();
				break;
			case 18:
				return $this->getPaymentDate();
				break;
			case 19:
				return $this->getPaymentMode();
				break;
			case 20:
				return $this->getPaymentDetails();
				break;
			case 21:
				return $this->getPaymentAmountEuro();
				break;
			case 22:
				return $this->getPaymentAmountSol();
				break;
			case 23:
				return $this->getTaux0BasesHt();
				break;
			case 24:
				return $this->getTaux0DiscountHt();
				break;
			case 25:
				return $this->getTaux0Amount();
				break;
			case 26:
				return $this->getTaux1BasesHt();
				break;
			case 27:
				return $this->getTaux1DiscountHt();
				break;
			case 28:
				return $this->getTaux1Amount();
				break;
			case 29:
				return $this->getTaux2BasesHt();
				break;
			case 30:
				return $this->getTaux2DiscountHt();
				break;
			case 31:
				return $this->getTaux2Amount();
				break;
			case 32:
				return $this->getTotalHt();
				break;
			case 33:
				return $this->getTotalTva();
				break;
			case 34:
				return $this->getComment();
				break;
			case 35:
				return $this->getFeesShippingHt();
				break;
			case 36:
				return $this->getFeesShippingRate();
				break;
			case 37:
				return $this->getFeesShippingTva();
				break;
			case 38:
				return $this->getFeesBillingHt();
				break;
			case 39:
				return $this->getFeesBillingRate();
				break;
			case 40:
				return $this->getFeesBillingTva();
				break;
			case 41:
				return $this->getCreatedAt();
				break;
			case 42:
				return $this->getUpdatedAt();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = KataoSupplierInvoicePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getKataoSupplierId(),
			$keys[2] => $this->getKataoPeriodId(),
			$keys[3] => $this->getStatus(),
			$keys[4] => $this->getSupplierName(),
			$keys[5] => $this->getSupplierEmail(),
			$keys[6] => $this->getSupplierAddress1(),
			$keys[7] => $this->getSupplierAddress2(),
			$keys[8] => $this->getSupplierZip(),
			$keys[9] => $this->getSupplierCity(),
			$keys[10] => $this->getKataoName(),
			$keys[11] => $this->getKataoAddress(),
			$keys[12] => $this->getKataoSiretNumber(),
			$keys[13] => $this->getKataoRcsNumber(),
			$keys[14] => $this->getKataoCapital(),
			$keys[15] => $this->getReference(),
			$keys[16] => $this->getInvoiceDate(),
			$keys[17] => $this->getDueDate(),
			$keys[18] => $this->getPaymentDate(),
			$keys[19] => $this->getPaymentMode(),
			$keys[20] => $this->getPaymentDetails(),
			$keys[21] => $this->getPaymentAmountEuro(),
			$keys[22] => $this->getPaymentAmountSol(),
			$keys[23] => $this->getTaux0BasesHt(),
			$keys[24] => $this->getTaux0DiscountHt(),
			$keys[25] => $this->getTaux0Amount(),
			$keys[26] => $this->getTaux1BasesHt(),
			$keys[27] => $this->getTaux1DiscountHt(),
			$keys[28] => $this->getTaux1Amount(),
			$keys[29] => $this->getTaux2BasesHt(),
			$keys[30] => $this->getTaux2DiscountHt(),
			$keys[31] => $this->getTaux2Amount(),
			$keys[32] => $this->getTotalHt(),
			$keys[33] => $this->getTotalTva(),
			$keys[34] => $this->getComment(),
			$keys[35] => $this->getFeesShippingHt(),
			$keys[36] => $this->getFeesShippingRate(),
			$keys[37] => $this->getFeesShippingTva(),
			$keys[38] => $this->getFeesBillingHt(),
			$keys[39] => $this->getFeesBillingRate(),
			$keys[40] => $this->getFeesBillingTva(),
			$keys[41] => $this->getCreatedAt(),
			$keys[42] => $this->getUpdatedAt(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KataoSupplierInvoicePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setKataoSupplierId($value);
				break;
			case 2:
				$this->setKataoPeriodId($value);
				break;
			case 3:
				$this->setStatus($value);
				break;
			case 4:
				$this->setSupplierName($value);
				break;
			case 5:
				$this->setSupplierEmail($value);
				break;
			case 6:
				$this->setSupplierAddress1($value);
				break;
			case 7:
				$this->setSupplierAddress2($value);
				break;
			case 8:
				$this->setSupplierZip($value);
				break;
			case 9:
				$this->setSupplierCity($value);
				break;
			case 10:
				$this->setKataoName($value);
				break;
			case 11:
				$this->setKataoAddress($value);
				break;
			case 12:
				$this->setKataoSiretNumber($value);
				break;
			case 13:
				$this->setKataoRcsNumber($value);
				break;
			case 14:
				$this->setKataoCapital($value);
				break;
			case 15:
				$this->setReference($value);
				break;
			case 16:
				$this->setInvoiceDate($value);
				break;
			case 17:
				$this->setDueDate($value);
				break;
			case 18:
				$this->setPaymentDate($value);
				break;
			case 19:
				$this->setPaymentMode($value);
				break;
			case 20:
				$this->setPaymentDetails($value);
				break;
			case 21:
				$this->setPaymentAmountEuro($value);
				break;
			case 22:
				$this->setPaymentAmountSol($value);
				break;
			case 23:
				$this->setTaux0BasesHt($value);
				break;
			case 24:
				$this->setTaux0DiscountHt($value);
				break;
			case 25:
				$this->setTaux0Amount($value);
				break;
			case 26:
				$this->setTaux1BasesHt($value);
				break;
			case 27:
				$this->setTaux1DiscountHt($value);
				break;
			case 28:
				$this->setTaux1Amount($value);
				break;
			case 29:
				$this->setTaux2BasesHt($value);
				break;
			case 30:
				$this->setTaux2DiscountHt($value);
				break;
			case 31:
				$this->setTaux2Amount($value);
				break;
			case 32:
				$this->setTotalHt($value);
				break;
			case 33:
				$this->setTotalTva($value);
				break;
			case 34:
				$this->setComment($value);
				break;
			case 35:
				$this->setFeesShippingHt($value);
				break;
			case 36:
				$this->setFeesShippingRate($value);
				break;
			case 37:
				$this->setFeesShippingTva($value);
				break;
			case 38:
				$this->setFeesBillingHt($value);
				break;
			case 39:
				$this->setFeesBillingRate($value);
				break;
			case 40:
				$this->setFeesBillingTva($value);
				break;
			case 41:
				$this->setCreatedAt($value);
				break;
			case 42:
				$this->setUpdatedAt($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = KataoSupplierInvoicePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setKataoSupplierId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setKataoPeriodId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setStatus($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setSupplierName($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setSupplierEmail($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setSupplierAddress1($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setSupplierAddress2($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setSupplierZip($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setSupplierCity($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setKataoName($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setKataoAddress($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setKataoSiretNumber($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setKataoRcsNumber($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setKataoCapital($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setReference($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setInvoiceDate($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setDueDate($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setPaymentDate($arr[$keys[18]]);
		if (array_key_exists($keys[19], $arr)) $this->setPaymentMode($arr[$keys[19]]);
		if (array_key_exists($keys[20], $arr)) $this->setPaymentDetails($arr[$keys[20]]);
		if (array_key_exists($keys[21], $arr)) $this->setPaymentAmountEuro($arr[$keys[21]]);
		if (array_key_exists($keys[22], $arr)) $this->setPaymentAmountSol($arr[$keys[22]]);
		if (array_key_exists($keys[23], $arr)) $this->setTaux0BasesHt($arr[$keys[23]]);
		if (array_key_exists($keys[24], $arr)) $this->setTaux0DiscountHt($arr[$keys[24]]);
		if (array_key_exists($keys[25], $arr)) $this->setTaux0Amount($arr[$keys[25]]);
		if (array_key_exists($keys[26], $arr)) $this->setTaux1BasesHt($arr[$keys[26]]);
		if (array_key_exists($keys[27], $arr)) $this->setTaux1DiscountHt($arr[$keys[27]]);
		if (array_key_exists($keys[28], $arr)) $this->setTaux1Amount($arr[$keys[28]]);
		if (array_key_exists($keys[29], $arr)) $this->setTaux2BasesHt($arr[$keys[29]]);
		if (array_key_exists($keys[30], $arr)) $this->setTaux2DiscountHt($arr[$keys[30]]);
		if (array_key_exists($keys[31], $arr)) $this->setTaux2Amount($arr[$keys[31]]);
		if (array_key_exists($keys[32], $arr)) $this->setTotalHt($arr[$keys[32]]);
		if (array_key_exists($keys[33], $arr)) $this->setTotalTva($arr[$keys[33]]);
		if (array_key_exists($keys[34], $arr)) $this->setComment($arr[$keys[34]]);
		if (array_key_exists($keys[35], $arr)) $this->setFeesShippingHt($arr[$keys[35]]);
		if (array_key_exists($keys[36], $arr)) $this->setFeesShippingRate($arr[$keys[36]]);
		if (array_key_exists($keys[37], $arr)) $this->setFeesShippingTva($arr[$keys[37]]);
		if (array_key_exists($keys[38], $arr)) $this->setFeesBillingHt($arr[$keys[38]]);
		if (array_key_exists($keys[39], $arr)) $this->setFeesBillingRate($arr[$keys[39]]);
		if (array_key_exists($keys[40], $arr)) $this->setFeesBillingTva($arr[$keys[40]]);
		if (array_key_exists($keys[41], $arr)) $this->setCreatedAt($arr[$keys[41]]);
		if (array_key_exists($keys[42], $arr)) $this->setUpdatedAt($arr[$keys[42]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(KataoSupplierInvoicePeer::DATABASE_NAME);

		if ($this->isColumnModified(KataoSupplierInvoicePeer::ID)) $criteria->add(KataoSupplierInvoicePeer::ID, $this->id);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::KATAO_SUPPLIER_ID)) $criteria->add(KataoSupplierInvoicePeer::KATAO_SUPPLIER_ID, $this->katao_supplier_id);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::KATAO_PERIOD_ID)) $criteria->add(KataoSupplierInvoicePeer::KATAO_PERIOD_ID, $this->katao_period_id);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::STATUS)) $criteria->add(KataoSupplierInvoicePeer::STATUS, $this->status);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::SUPPLIER_NAME)) $criteria->add(KataoSupplierInvoicePeer::SUPPLIER_NAME, $this->supplier_name);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::SUPPLIER_EMAIL)) $criteria->add(KataoSupplierInvoicePeer::SUPPLIER_EMAIL, $this->supplier_email);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::SUPPLIER_ADDRESS1)) $criteria->add(KataoSupplierInvoicePeer::SUPPLIER_ADDRESS1, $this->supplier_address1);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::SUPPLIER_ADDRESS2)) $criteria->add(KataoSupplierInvoicePeer::SUPPLIER_ADDRESS2, $this->supplier_address2);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::SUPPLIER_ZIP)) $criteria->add(KataoSupplierInvoicePeer::SUPPLIER_ZIP, $this->supplier_zip);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::SUPPLIER_CITY)) $criteria->add(KataoSupplierInvoicePeer::SUPPLIER_CITY, $this->supplier_city);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::KATAO_NAME)) $criteria->add(KataoSupplierInvoicePeer::KATAO_NAME, $this->katao_name);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::KATAO_ADDRESS)) $criteria->add(KataoSupplierInvoicePeer::KATAO_ADDRESS, $this->katao_address);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::KATAO_SIRET_NUMBER)) $criteria->add(KataoSupplierInvoicePeer::KATAO_SIRET_NUMBER, $this->katao_siret_number);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::KATAO_RCS_NUMBER)) $criteria->add(KataoSupplierInvoicePeer::KATAO_RCS_NUMBER, $this->katao_rcs_number);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::KATAO_CAPITAL)) $criteria->add(KataoSupplierInvoicePeer::KATAO_CAPITAL, $this->katao_capital);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::REFERENCE)) $criteria->add(KataoSupplierInvoicePeer::REFERENCE, $this->reference);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::INVOICE_DATE)) $criteria->add(KataoSupplierInvoicePeer::INVOICE_DATE, $this->invoice_date);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::DUE_DATE)) $criteria->add(KataoSupplierInvoicePeer::DUE_DATE, $this->due_date);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::PAYMENT_DATE)) $criteria->add(KataoSupplierInvoicePeer::PAYMENT_DATE, $this->payment_date);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::PAYMENT_MODE)) $criteria->add(KataoSupplierInvoicePeer::PAYMENT_MODE, $this->payment_mode);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::PAYMENT_DETAILS)) $criteria->add(KataoSupplierInvoicePeer::PAYMENT_DETAILS, $this->payment_details);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::PAYMENT_AMOUNT_EURO)) $criteria->add(KataoSupplierInvoicePeer::PAYMENT_AMOUNT_EURO, $this->payment_amount_euro);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::PAYMENT_AMOUNT_SOL)) $criteria->add(KataoSupplierInvoicePeer::PAYMENT_AMOUNT_SOL, $this->payment_amount_sol);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::TAUX0_BASES_HT)) $criteria->add(KataoSupplierInvoicePeer::TAUX0_BASES_HT, $this->taux0_bases_ht);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::TAUX0_DISCOUNT_HT)) $criteria->add(KataoSupplierInvoicePeer::TAUX0_DISCOUNT_HT, $this->taux0_discount_ht);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::TAUX0_AMOUNT)) $criteria->add(KataoSupplierInvoicePeer::TAUX0_AMOUNT, $this->taux0_amount);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::TAUX1_BASES_HT)) $criteria->add(KataoSupplierInvoicePeer::TAUX1_BASES_HT, $this->taux1_bases_ht);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::TAUX1_DISCOUNT_HT)) $criteria->add(KataoSupplierInvoicePeer::TAUX1_DISCOUNT_HT, $this->taux1_discount_ht);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::TAUX1_AMOUNT)) $criteria->add(KataoSupplierInvoicePeer::TAUX1_AMOUNT, $this->taux1_amount);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::TAUX2_BASES_HT)) $criteria->add(KataoSupplierInvoicePeer::TAUX2_BASES_HT, $this->taux2_bases_ht);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::TAUX2_DISCOUNT_HT)) $criteria->add(KataoSupplierInvoicePeer::TAUX2_DISCOUNT_HT, $this->taux2_discount_ht);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::TAUX2_AMOUNT)) $criteria->add(KataoSupplierInvoicePeer::TAUX2_AMOUNT, $this->taux2_amount);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::TOTAL_HT)) $criteria->add(KataoSupplierInvoicePeer::TOTAL_HT, $this->total_ht);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::TOTAL_TVA)) $criteria->add(KataoSupplierInvoicePeer::TOTAL_TVA, $this->total_tva);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::COMMENT)) $criteria->add(KataoSupplierInvoicePeer::COMMENT, $this->comment);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::FEES_SHIPPING_HT)) $criteria->add(KataoSupplierInvoicePeer::FEES_SHIPPING_HT, $this->fees_shipping_ht);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::FEES_SHIPPING_RATE)) $criteria->add(KataoSupplierInvoicePeer::FEES_SHIPPING_RATE, $this->fees_shipping_rate);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::FEES_SHIPPING_TVA)) $criteria->add(KataoSupplierInvoicePeer::FEES_SHIPPING_TVA, $this->fees_shipping_tva);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::FEES_BILLING_HT)) $criteria->add(KataoSupplierInvoicePeer::FEES_BILLING_HT, $this->fees_billing_ht);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::FEES_BILLING_RATE)) $criteria->add(KataoSupplierInvoicePeer::FEES_BILLING_RATE, $this->fees_billing_rate);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::FEES_BILLING_TVA)) $criteria->add(KataoSupplierInvoicePeer::FEES_BILLING_TVA, $this->fees_billing_tva);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::CREATED_AT)) $criteria->add(KataoSupplierInvoicePeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(KataoSupplierInvoicePeer::UPDATED_AT)) $criteria->add(KataoSupplierInvoicePeer::UPDATED_AT, $this->updated_at);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(KataoSupplierInvoicePeer::DATABASE_NAME);

		$criteria->add(KataoSupplierInvoicePeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of KataoSupplierInvoice (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setKataoSupplierId($this->katao_supplier_id);

		$copyObj->setKataoPeriodId($this->katao_period_id);

		$copyObj->setStatus($this->status);

		$copyObj->setSupplierName($this->supplier_name);

		$copyObj->setSupplierEmail($this->supplier_email);

		$copyObj->setSupplierAddress1($this->supplier_address1);

		$copyObj->setSupplierAddress2($this->supplier_address2);

		$copyObj->setSupplierZip($this->supplier_zip);

		$copyObj->setSupplierCity($this->supplier_city);

		$copyObj->setKataoName($this->katao_name);

		$copyObj->setKataoAddress($this->katao_address);

		$copyObj->setKataoSiretNumber($this->katao_siret_number);

		$copyObj->setKataoRcsNumber($this->katao_rcs_number);

		$copyObj->setKataoCapital($this->katao_capital);

		$copyObj->setReference($this->reference);

		$copyObj->setInvoiceDate($this->invoice_date);

		$copyObj->setDueDate($this->due_date);

		$copyObj->setPaymentDate($this->payment_date);

		$copyObj->setPaymentMode($this->payment_mode);

		$copyObj->setPaymentDetails($this->payment_details);

		$copyObj->setPaymentAmountEuro($this->payment_amount_euro);

		$copyObj->setPaymentAmountSol($this->payment_amount_sol);

		$copyObj->setTaux0BasesHt($this->taux0_bases_ht);

		$copyObj->setTaux0DiscountHt($this->taux0_discount_ht);

		$copyObj->setTaux0Amount($this->taux0_amount);

		$copyObj->setTaux1BasesHt($this->taux1_bases_ht);

		$copyObj->setTaux1DiscountHt($this->taux1_discount_ht);

		$copyObj->setTaux1Amount($this->taux1_amount);

		$copyObj->setTaux2BasesHt($this->taux2_bases_ht);

		$copyObj->setTaux2DiscountHt($this->taux2_discount_ht);

		$copyObj->setTaux2Amount($this->taux2_amount);

		$copyObj->setTotalHt($this->total_ht);

		$copyObj->setTotalTva($this->total_tva);

		$copyObj->setComment($this->comment);

		$copyObj->setFeesShippingHt($this->fees_shipping_ht);

		$copyObj->setFeesShippingRate($this->fees_shipping_rate);

		$copyObj->setFeesShippingTva($this->fees_shipping_tva);

		$copyObj->setFeesBillingHt($this->fees_billing_ht);

		$copyObj->setFeesBillingRate($this->fees_billing_rate);

		$copyObj->setFeesBillingTva($this->fees_billing_tva);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getKataoSupplierInvoiceProducts() as $relObj) {
				$copyObj->addKataoSupplierInvoiceProduct($relObj->copy($deepCopy));
			}

			foreach($this->getKataoSupplierInvoiceOrders() as $relObj) {
				$copyObj->addKataoSupplierInvoiceOrder($relObj->copy($deepCopy));
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     KataoSupplierInvoice Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     KataoSupplierInvoicePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new KataoSupplierInvoicePeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a KataoSupplier object.
	 *
	 * @param      KataoSupplier $v
	 * @return     void
	 * @throws     PropelException
	 */
	public function setKataoSupplier($v)
	{


		if ($v === null) {
			$this->setKataoSupplierId(NULL);
		} else {
			$this->setKataoSupplierId($v->getId());
		}


		$this->aKataoSupplier = $v;
	}


	/**
	 * Get the associated KataoSupplier object
	 *
	 * @param      Connection Optional Connection object.
	 * @return     KataoSupplier The associated KataoSupplier object.
	 * @throws     PropelException
	 */
	public function getKataoSupplier($con = null)
	{
		if ($this->aKataoSupplier === null && ($this->katao_supplier_id !== null)) {
			// include the related Peer class
			$this->aKataoSupplier = KataoSupplierPeer::retrieveByPK($this->katao_supplier_id, $con);

			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = KataoSupplierPeer::retrieveByPK($this->katao_supplier_id, $con);
			   $obj->addKataoSuppliers($this);
			 */
		}
		return $this->aKataoSupplier;
	}

	/**
	 * Declares an association between this object and a KataoPeriod object.
	 *
	 * @param      KataoPeriod $v
	 * @return     void
	 * @throws     PropelException
	 */
	public function setKataoPeriod($v)
	{


		if ($v === null) {
			$this->setKataoPeriodId(NULL);
		} else {
			$this->setKataoPeriodId($v->getId());
		}


		$this->aKataoPeriod = $v;
	}


	/**
	 * Get the associated KataoPeriod object
	 *
	 * @param      Connection Optional Connection object.
	 * @return     KataoPeriod The associated KataoPeriod object.
	 * @throws     PropelException
	 */
	public function getKataoPeriod($con = null)
	{
		if ($this->aKataoPeriod === null && ($this->katao_period_id !== null)) {
			// include the related Peer class
			$this->aKataoPeriod = KataoPeriodPeer::retrieveByPK($this->katao_period_id, $con);

			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = KataoPeriodPeer::retrieveByPK($this->katao_period_id, $con);
			   $obj->addKataoPeriods($this);
			 */
		}
		return $this->aKataoPeriod;
	}

	/**
	 * Temporary storage of collKataoSupplierInvoiceProducts to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return     void
	 */
	public function initKataoSupplierInvoiceProducts()
	{
		if ($this->collKataoSupplierInvoiceProducts === null) {
			$this->collKataoSupplierInvoiceProducts = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoSupplierInvoice has previously
	 * been saved, it will retrieve related KataoSupplierInvoiceProducts from storage.
	 * If this KataoSupplierInvoice is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param      Connection $con
	 * @param      Criteria $criteria
	 * @throws     PropelException
	 */
	public function getKataoSupplierInvoiceProducts($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoSupplierInvoiceProducts === null) {
			if ($this->isNew()) {
			   $this->collKataoSupplierInvoiceProducts = array();
			} else {

				$criteria->add(KataoSupplierInvoiceProductPeer::KATAO_SUPPLIER_INVOICE_ID, $this->getId());

				KataoSupplierInvoiceProductPeer::addSelectColumns($criteria);
				$this->collKataoSupplierInvoiceProducts = KataoSupplierInvoiceProductPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(KataoSupplierInvoiceProductPeer::KATAO_SUPPLIER_INVOICE_ID, $this->getId());

				KataoSupplierInvoiceProductPeer::addSelectColumns($criteria);
				if (!isset($this->lastKataoSupplierInvoiceProductCriteria) || !$this->lastKataoSupplierInvoiceProductCriteria->equals($criteria)) {
					$this->collKataoSupplierInvoiceProducts = KataoSupplierInvoiceProductPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastKataoSupplierInvoiceProductCriteria = $criteria;
		return $this->collKataoSupplierInvoiceProducts;
	}

	/**
	 * Returns the number of related KataoSupplierInvoiceProducts.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      Connection $con
	 * @throws     PropelException
	 */
	public function countKataoSupplierInvoiceProducts($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(KataoSupplierInvoiceProductPeer::KATAO_SUPPLIER_INVOICE_ID, $this->getId());

		return KataoSupplierInvoiceProductPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a KataoSupplierInvoiceProduct object to this object
	 * through the KataoSupplierInvoiceProduct foreign key attribute
	 *
	 * @param      KataoSupplierInvoiceProduct $l KataoSupplierInvoiceProduct
	 * @return     void
	 * @throws     PropelException
	 */
	public function addKataoSupplierInvoiceProduct(KataoSupplierInvoiceProduct $l)
	{
		$this->collKataoSupplierInvoiceProducts[] = $l;
		$l->setKataoSupplierInvoice($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoSupplierInvoice is new, it will return
	 * an empty collection; or if this KataoSupplierInvoice has previously
	 * been saved, it will retrieve related KataoSupplierInvoiceProducts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in KataoSupplierInvoice.
	 */
	public function getKataoSupplierInvoiceProductsJoinKataoProduct($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoSupplierInvoiceProducts === null) {
			if ($this->isNew()) {
				$this->collKataoSupplierInvoiceProducts = array();
			} else {

				$criteria->add(KataoSupplierInvoiceProductPeer::KATAO_SUPPLIER_INVOICE_ID, $this->getId());

				$this->collKataoSupplierInvoiceProducts = KataoSupplierInvoiceProductPeer::doSelectJoinKataoProduct($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(KataoSupplierInvoiceProductPeer::KATAO_SUPPLIER_INVOICE_ID, $this->getId());

			if (!isset($this->lastKataoSupplierInvoiceProductCriteria) || !$this->lastKataoSupplierInvoiceProductCriteria->equals($criteria)) {
				$this->collKataoSupplierInvoiceProducts = KataoSupplierInvoiceProductPeer::doSelectJoinKataoProduct($criteria, $con);
			}
		}
		$this->lastKataoSupplierInvoiceProductCriteria = $criteria;

		return $this->collKataoSupplierInvoiceProducts;
	}

	/**
	 * Temporary storage of collKataoSupplierInvoiceOrders to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return     void
	 */
	public function initKataoSupplierInvoiceOrders()
	{
		if ($this->collKataoSupplierInvoiceOrders === null) {
			$this->collKataoSupplierInvoiceOrders = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoSupplierInvoice has previously
	 * been saved, it will retrieve related KataoSupplierInvoiceOrders from storage.
	 * If this KataoSupplierInvoice is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param      Connection $con
	 * @param      Criteria $criteria
	 * @throws     PropelException
	 */
	public function getKataoSupplierInvoiceOrders($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoSupplierInvoiceOrders === null) {
			if ($this->isNew()) {
			   $this->collKataoSupplierInvoiceOrders = array();
			} else {

				$criteria->add(KataoSupplierInvoiceOrderPeer::KATAO_SUPPLIER_INVOICE_ID, $this->getId());

				KataoSupplierInvoiceOrderPeer::addSelectColumns($criteria);
				$this->collKataoSupplierInvoiceOrders = KataoSupplierInvoiceOrderPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(KataoSupplierInvoiceOrderPeer::KATAO_SUPPLIER_INVOICE_ID, $this->getId());

				KataoSupplierInvoiceOrderPeer::addSelectColumns($criteria);
				if (!isset($this->lastKataoSupplierInvoiceOrderCriteria) || !$this->lastKataoSupplierInvoiceOrderCriteria->equals($criteria)) {
					$this->collKataoSupplierInvoiceOrders = KataoSupplierInvoiceOrderPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastKataoSupplierInvoiceOrderCriteria = $criteria;
		return $this->collKataoSupplierInvoiceOrders;
	}

	/**
	 * Returns the number of related KataoSupplierInvoiceOrders.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      Connection $con
	 * @throws     PropelException
	 */
	public function countKataoSupplierInvoiceOrders($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(KataoSupplierInvoiceOrderPeer::KATAO_SUPPLIER_INVOICE_ID, $this->getId());

		return KataoSupplierInvoiceOrderPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a KataoSupplierInvoiceOrder object to this object
	 * through the KataoSupplierInvoiceOrder foreign key attribute
	 *
	 * @param      KataoSupplierInvoiceOrder $l KataoSupplierInvoiceOrder
	 * @return     void
	 * @throws     PropelException
	 */
	public function addKataoSupplierInvoiceOrder(KataoSupplierInvoiceOrder $l)
	{
		$this->collKataoSupplierInvoiceOrders[] = $l;
		$l->setKataoSupplierInvoice($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoSupplierInvoice is new, it will return
	 * an empty collection; or if this KataoSupplierInvoice has previously
	 * been saved, it will retrieve related KataoSupplierInvoiceOrders from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in KataoSupplierInvoice.
	 */
	public function getKataoSupplierInvoiceOrdersJoinKataoOrder($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoSupplierInvoiceOrders === null) {
			if ($this->isNew()) {
				$this->collKataoSupplierInvoiceOrders = array();
			} else {

				$criteria->add(KataoSupplierInvoiceOrderPeer::KATAO_SUPPLIER_INVOICE_ID, $this->getId());

				$this->collKataoSupplierInvoiceOrders = KataoSupplierInvoiceOrderPeer::doSelectJoinKataoOrder($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(KataoSupplierInvoiceOrderPeer::KATAO_SUPPLIER_INVOICE_ID, $this->getId());

			if (!isset($this->lastKataoSupplierInvoiceOrderCriteria) || !$this->lastKataoSupplierInvoiceOrderCriteria->equals($criteria)) {
				$this->collKataoSupplierInvoiceOrders = KataoSupplierInvoiceOrderPeer::doSelectJoinKataoOrder($criteria, $con);
			}
		}
		$this->lastKataoSupplierInvoiceOrderCriteria = $criteria;

		return $this->collKataoSupplierInvoiceOrders;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseKataoSupplierInvoice:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseKataoSupplierInvoice::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseKataoSupplierInvoice
